#include <stdio.h>
#include <stdlib.h>

#include "bignum.h"
#include "print.h"
void
test_add()
{
	struct bignum *a, *b, *c;
	unsigned short av[] = { 0x0000, 0xffff };
	unsigned short bv[] = { 0xffff };
	unsigned short aav[] = { 0xffff, 0xffff };
	unsigned short bbv[] = { 0x0001 };
	unsigned short aaa[] = { 0xffff, 0xffff };
	unsigned short bbb[] = { 0xffff, 0xfffe };

	a = bnum_new();
	b = bnum_new();
	c = bnum_new();

	bnum_set(a, av, 2, 0);
	bnum_set(b, bv, 1, 0);

	bnum_add(c, a, b);

	printf("0xffff0000 + 0x0000ffff = 0xFFFF.FFFF\nbnum_add return:          ");
	bnum_printhex(c);
	
	printf("\n");

	bnum_set(b, bv, 1, 1);
	bnum_add(c, a, b);

	printf("0xffff0000 - 0x0000ffff = 0xFFFE.0001\nbnum_add return:          ");
	bnum_printhex(c);
	printf("\n");

	bnum_set(a, av, 2, 1);
	bnum_set(b, bv, 1, 0);
	bnum_add(c, a, b);

	printf("-0xffff0000 + 0x0000ffff = -0xFFFE.0001\nbnum_add return:          ");
	bnum_printhex(c);
	printf("\n");

	bnum_set(a, av, 2, 1);
	bnum_set(b, bv, 1, 1);
	bnum_add(c, a, b);

	printf("-0xffff0000 + (-0x0000ffff) = -0xFFFF.FFFF\nbnum_add return:             ");
	bnum_printhex(c);
	printf("\n");

	bnum_set(a, aav, 2, 0);
	bnum_set(b, bbv, 1, 0);
	bnum_add(c, a, b);

	printf("0xffffffff + 0x00000001 = 0x0001.0000.0000\nbnum_add return:          ");
	bnum_printhex(c);
	printf("\n");

	bnum_set(a, aav, 2, 1);
	bnum_set(b, bbv, 1, 0);
	bnum_add(c, a, b);

	printf("-0xffffffff + 0x00000001 = -0xFFFF.FFFE\nbnum_add return:          ");
	bnum_printhex(c);

	printf("\n");

	bnum_set(a, aav, 2, 0);
	bnum_set(b, bbv, 1, 1);
	bnum_add(c, a, b);

	printf("0xffffffff + (-0x00000001) = 0xFFFF.FFFE\nbnum_add return:             ");
	bnum_printhex(c);

	printf("\n");

	bnum_set(a, aaa, 2, 0);
	bnum_set(b, bbb, 2, 0);
	bnum_add(c, a, b);

	printf("0xffffffff + 0xfffeffff = 0x0001.FFFE.FFFE\nbnum_add return:          ");
	bnum_printhex(c);

	printf("\n");

	bnum_set(a, aaa, 2, 1);
	bnum_set(b, bbb, 2, 0);
	bnum_add(c, a, b);

	printf("-0xffffffff + 0xfffeffff = -0x0001.0000\nbnum_add return:          ");
	bnum_printhex(c);

	printf("\n");

	bnum_set(a, aaa, 2, 0);
	bnum_set(b, bbb, 2, 1);
	bnum_add(c, a, b);

	printf("0xffffffff + (-0xfffeffff) = 0x0001.0000\nbnum_add return:             ");
	bnum_printhex(c);

	printf("\n");

	bnum_set(a, aaa, 2, 1);
	bnum_set(b, bbb, 2, 1);
	bnum_add(c, a, b);

	printf("-0xffffffff + (-0xfffeffff) = -0x0001.FFFE.FFFE\nbnum_add return:             ");
	bnum_printhex(c);

	printf("\n");
	
	bnum_free(&a);
	bnum_free(&b);
	bnum_free(&c);
}

int
main(int argc, char *argv[])
{
	test_add();

	return 0;

}